// -----JS CODE-----
// @input Component.BlendShapes blendShape
// @input string mouthBlendName
// @input string eyeBlendName
// @input float speed = 1.0

global.touchSystem.touchBlocking = true;

var timeStartedLerping = 0.0;
var blendShapeStartValue = 0.0;
var blendShapeEndValue = 1.0;
var isLerping = false;
var isForward = true;
var percentageComplete = 0;
var isEyeClosed = false;
var randomTime;


function onTouchStart()
{
    if(isForward)
    {
        startMovingBlendShape(percentageComplete, 1);
    }
    else
    {
        startMovingBlendShape(percentageComplete, 0);
    }
}

function onTouchEnd()
{
    isLerping = false;
}

function onUpdate()
{
    if(isLerping)
    {
        var timeSinceStarted = getTime() - timeStartedLerping;
        percentageComplete = timeSinceStarted / script.speed;
        var smoothedValue = lerp(blendShapeStartValue, blendShapeEndValue, percentageComplete);
        script.blendShape.setBlendShape(script.mouthBlendName, smoothedValue);

        if(percentageComplete >= 1.0)
        {
            isLerping = false;
            if(isForward)
            {
                startMovingBlendShape(1,0);
                isForward = false;
            }
            else
            {
                startMovingBlendShape(0,1);
                isForward = true;
            }
        }
    }
}

function startMovingBlendShape(startValue, endValue)
{
    isLerping = true;
    timeStartedLerping = getTime();
    blendShapeStartValue = startValue;
    blendShapeEndValue = endValue;
}

function lerp(a, b, t)
{
    return a + t * (b - a);


}

var delayedEvent = script.createEvent("DelayedCallbackEvent");
delayedEvent.bind(blink);

function blink()
{
    if(isEyeClosed)
    {
        script.blendShape.setBlendShape(script.eyeBlendName, 0);
        isEyeClosed = false;
        randomTime = Math.floor(Math.random() * 3) + 1;
        delayedEvent.reset(randomTime);
    }
    else
    {
        script.blendShape.setBlendShape(script.eyeBlendName, 1);
        isEyeClosed = true;
        randomTime = Math.floor(Math.random() * 3) + 1;
        delayedEvent.reset(randomTime);
    }
}

randomTime = Math.floor(Math.random() * 3) + 1;
delayedEvent.reset(randomTime);

var touchStartEvent = script.createEvent("TouchStartEvent");
touchStartEvent.bind(onTouchStart);

var touchEndEvent = script.createEvent("TouchEndEvent");
touchEndEvent.bind(onTouchEnd);

var updateEvent = script.createEvent("UpdateEvent");
updateEvent.bind(onUpdate);

